//      _______________________________
//_____/                               \ 
//____/   base.js - fonctions de base   \ 
//    \_________________________________/  
//
//

//Fonctions d'affichage


//Initialise la barre de titre du navigateur
function Affiche_titre_navigateur(atn)
{
 document.title=atn;
}

//Affiche le bandeau de titre
function Affiche_bandeau(abt)
{
var z=document.getElementById("bandeau");
z.innerHTML=abt;
}



/*
include en javascript : NE FONCTIONNE PAS POUR L'INSTANT !
----------------------------------------------------------

source : http://sametmax.com/include-require-import-en-javascript/

On va créer une balise <script></script> et la faire pointer sur le fichier à télécharger. Ainsi on utilise le mécanisme naturel pour le navigateur d’include du code.
*/

var include = function(url, callback){
 
    /* on crée une balise<script type="text/javascript"></script> */
    var script = document.createElement('script');
    script.type = 'text/javascript';
 
    /* On fait pointer la balise sur le script qu'on veut charger
       avec en prime un timestamp pour éviter les problèmes de cache
    */
 
    script.src = url + '?' + (new Date().getTime());
 
    /* On dit d'exécuter cette fonction une fois que le script est chargé */
    if (callback) {
        script.onreadystatechange = callback;
        script.onload = script.onreadystatechange;
    }
 
    /* On rajoute la balise script dans le head, ce qui démarre le téléchargement */
    document.getElementsByTagName('head')[0].appendChild(script);
    /* Et en fait, je veux rajouter le contenu du fichier dans un élément particulier : page */
    //var zzz=document.getElementById("page");
    //zzz.appendChild(script);
}

/*
Ca s’utilise comme ça:

include('http://adressedemonscript.com/fichier.js', function() {
    code à exécuter une fois que le script est chargé
})

La partie callback est très importante. En effet, si vous essayez d’exécuter du code après include() qui dépend du code chargé par include(), ça va foirer : le code n’est pas encore téléchargé. 
En effet, les navigateurs téléchargent les balises scripts en arrière plan et en parallèle :

include('http://adressedemonscript.com/fichier.js'); //code à exécuter une fois que le script est chargé

Il faut donc mettre ce code dans un callback, pour garantir qu’il soit lancé quand le script a terminé de chargé.
*/

//include('./ml_balacal.html', function() {});


    function dragStart(e) {
      
      if (e.target !== e.currentTarget && deplacement) {
        active = true;
        e.preventDefault();

        // this is the item we are interacting with
        activeItem = e.target;

        if (activeItem !== null) {
          if (!activeItem.xOffset) {
            activeItem.xOffset = 0;
          }

          if (!activeItem.yOffset) {
            activeItem.yOffset = 0;
          }

          if (e.type === "touchstart") {
            activeItem.initialX = e.touches[0].clientX - activeItem.xOffset;
            activeItem.initialY = e.touches[0].clientY - activeItem.yOffset;
          } else {
            activeItem.initialX = e.clientX - activeItem.xOffset;
            activeItem.initialY = e.clientY - activeItem.yOffset;
          }
        }
      }
    }

    function dragEnd(e) {
      if (activeItem !== null) {
        activeItem.initialX = activeItem.currentX;
        activeItem.initialY = activeItem.currentY;
      }

      active = false;
      activeItem = null;
    }

    function drag(e) {
      if (active) {
        if (e.type === "touchmove") {
          e.preventDefault();

          activeItem.currentX = e.touches[0].clientX - activeItem.initialX;
          activeItem.currentY = e.touches[0].clientY - activeItem.initialY;
        } else {
          e.preventDefault();
          activeItem.currentX = e.clientX - activeItem.initialX;
          activeItem.currentY = e.clientY - activeItem.initialY;
        }

        activeItem.xOffset = activeItem.currentX;
        activeItem.yOffset = activeItem.currentY;

        setTranslate(activeItem.currentX, activeItem.currentY, activeItem);
      }
    }


//transforme une coordonnée ave px en nombre entier (sans px)
function coordNb(se)
{
 se=se.replace("px","");
 return(parseInt(se));
}

function setTranslate(xPos, yPos, el) 
{
 if(!el.mobilite)return;
 var elstyleleft=coordNb(el.style.left);
 var elstyletop=coordNb(el.style.top);
 var elstylewidth=coordNb(el.style.width);
 var elstyleheight=coordNb(el.style.height);
 var stop=false;
 
 if((elstyleleft + xPos) < 0) {xPos = 10-elstyleleft; el.xOffset=xPos; stop=true;}
 if((elstyleleft + xPos) > (largConteneur - elstylewidth)) {xPos = largConteneur - elstyleleft - elstylewidth - 10; el.xOffset=xPos; stop=true;}
 
 if((elstyletop + yPos) < 0) {yPos = 10-elstyletop; el.yOffset=yPos; stop=true;}

 //if(niveau.substr(0,2)=="nb" && (elstyletop + yPos) > 182) {yPos = 212 - elstyletop; el.yOffset=yPos;}
 //if(niveau.substr(0,2)=="po" && (elstyletop + yPos) > 142) {yPos = 172 - elstyletop; el.yOffset=yPos;}
 
 //Place_nombre(nb0,gy+10,gx+271);
 el.bulle=-1;
 my=10;mx=271;if((elstyletop + yPos) < gy+my+aimant && (elstyletop + yPos) > gy+my-aimant && (elstyleleft + xPos) < gx+mx+aimant && (elstyleleft + xPos) > gx+mx-aimant){yPos = gy+my - elstyletop; el.yOffset=yPos; xPos = gx+mx - elstyleleft; el.xOffset=xPos;el.bulle=0;}
 //Place_nombre(nb1,gy+88,gx+396);
 my=88;mx=396;if((elstyletop + yPos) < gy+my+aimant && (elstyletop + yPos) > gy+my-aimant && (elstyleleft + xPos) < gx+mx+aimant && (elstyleleft + xPos) > gx+mx-aimant){yPos = gy+my - elstyletop; el.yOffset=yPos; xPos = gx+mx - elstyleleft; el.xOffset=xPos;el.bulle=1;}
 //Place_nombre(nb2,gy+171,gx+536);
 my=171;mx=536;if((elstyletop + yPos) < gy+my+aimant && (elstyletop + yPos) > gy+my-aimant && (elstyleleft + xPos) < gx+mx+aimant && (elstyleleft + xPos) > gx+mx-aimant){yPos = gy+my - elstyletop; el.yOffset=yPos; xPos = gx+mx - elstyleleft; el.xOffset=xPos;el.bulle=2;}
 //Place_nombre(nb3,gy+250,gx+396);
 my=250;mx=396;if((elstyletop + yPos) < gy+my+aimant && (elstyletop + yPos) > gy+my-aimant && (elstyleleft + xPos) < gx+mx+aimant && (elstyleleft + xPos) > gx+mx-aimant){yPos = gy+my - elstyletop; el.yOffset=yPos; xPos = gx+mx - elstyleleft; el.xOffset=xPos;el.bulle=3;}
 //Place_nombre(nb4,gy+338,gx+271);
 my=338;mx=271;if((elstyletop + yPos) < gy+my+aimant && (elstyletop + yPos) > gy+my-aimant && (elstyleleft + xPos) < gx+mx+aimant && (elstyleleft + xPos) > gx+mx-aimant){yPos = gy+my - elstyletop; el.yOffset=yPos; xPos = gx+mx - elstyleleft; el.xOffset=xPos;el.bulle=4;}
 //Place_nombre(nb5,gy+250,gx+138);
 my=250;mx=138;if((elstyletop + yPos) < gy+my+aimant && (elstyletop + yPos) > gy+my-aimant && (elstyleleft + xPos) < gx+mx+aimant && (elstyleleft + xPos) > gx+mx-aimant){yPos = gy+my - elstyletop; el.yOffset=yPos; xPos = gx+mx - elstyleleft; el.xOffset=xPos;el.bulle=5;}
 //Place_nombre(nb6,gy+171,gx+6);
 my=171;mx=6;if((elstyletop + yPos) < gy+my+aimant && (elstyletop + yPos) > gy+my-aimant && (elstyleleft + xPos) < gx+mx+aimant && (elstyleleft + xPos) > gx+mx-aimant){yPos = gy+my - elstyletop; el.yOffset=yPos; xPos = gx+mx - elstyleleft; el.xOffset=xPos;el.bulle=6;}
 //Place_nombre(nb7,gy+88,gx+138);
 my=88;mx=138;if((elstyletop + yPos) < gy+my+aimant && (elstyletop + yPos) > gy+my-aimant && (elstyleleft + xPos) < gx+mx+aimant && (elstyleleft + xPos) > gx+mx-aimant){yPos = gy+my - elstyletop; el.yOffset=yPos; xPos = gx+mx - elstyleleft; el.xOffset=xPos;el.bulle=7;}
 //Place_nombre(nb8,gy+171,gx+271);
 my=171;mx=271;if((elstyletop + yPos) < gy+my+aimant && (elstyletop + yPos) > gy+my-aimant && (elstyleleft + xPos) < gx+mx+aimant && (elstyleleft + xPos) > gx+mx-aimant){yPos = gy+my - elstyletop; el.yOffset=yPos; xPos = gx+mx - elstyleleft; el.xOffset=xPos;el.bulle=8;}

 el.style.transform = "translate3d(" + xPos + "px, " + yPos + "px, 0)";
 if(stop){active=false;activeItem=null;}
}

function Centre_element(ee)
{
 var z=document.getElementById(ee);
 z.style.left=margeg+ "px";
}

function Selectionne_niveau(nv)
{
 document.location.href="./index.html?niveau="+nv;
}

function Recupere_GET(param)
{
 var vars = {};
 window.location.href.replace( location.hash, '' ).replace( 
 /[?&]+([^=&]+)=?([^&]*)?/gi, // regexp
 function( m, key, value ) { // callback
  vars[key] = value !== undefined ? value : '';
  }
 );

 if ( param ) {
 return vars[param] ? vars[param] : "";//null;	
 }
 return vars;
}

function Affiche_element(ae)
{
 var z=document.getElementById(ae);
 z.style.display="block";
}

function Cache_element(ae)
{
 var z=document.getElementById(ae);
 z.style.display="none";
}

function Occulte_element(ae)
{
 var z=document.getElementById(ae);
 z.style.visibility="hidden";
}

function Desocculte_element(ae)
{
 var z=document.getElementById(ae);
 z.style.visibility="visible";
}

function Ecris_element(ae,at)
{
 var z=document.getElementById(ae);
 z.innerHTML=at;
}

