//      _________________________________________
//_____/                                         \ 
//____/   coeur.js - paramétrages spécifiques     \ 
//    \___________________________________________/  
//
//

//Paramétrages de l'application
Affiche_titre_navigateur("NonaMagik : la grille à nombres");

//Variables pour les dimensions
var largConteneur=900;
var hautConteneur=273;
var wtot=document.body.offsetWidth;
var margeg=parseInt((wtot - largConteneur) / 2);
var deplacement=true;
var aimant=30;//force de la magnétisation pour le positionnement des nb

//Variables pour les options
var change_option=false;
var chrono=0; var zechrono=null;
var dureemaxi=600; //10 minutes maxi de jeu chronométré
var types_scores=new Array("","chrono1","chrono3","chrono5","minuteur3","minuteur6");
var npa=3; var npaz=Recupere_GET("npa"); if(npaz !== "")npa=npaz;
var odg=2; var odgz=Recupere_GET("odg"); if(odgz !== "")odg=odgz;
var vp=0; var vpz=Recupere_GET("vp"); if(vpz !== "")vp=vpz;
var nbcalculs=0; var nbcalculsz=Recupere_GET("nbcalculs"); if(nbcalculsz !== "")nbcalculs=nbcalculsz;
var nbreussites=0; var nbreussitesz=Recupere_GET("nbreussites"); if(nbreussitesz !== "")nbreussites=nbreussitesz;
var temps=0; var tempsz=Recupere_GET("temps"); if(tempsz !== "")temps=tempsz;
var mode = "entrainement"; var modez=Recupere_GET("mode"); if(modez !== "")mode=modez;
var score = "minuteur3"; var scorez=Recupere_GET("score");if(scorez !== "")score=scorez;

//Variables pour l'affichage de la grille des nombres
var map=true;
var gx=10;
var gy=10;
var somme_zone=37;
var matrice=new Array(8,11,4,10,1,14,5,6,12);
var positions=new Array(0,1,2,3,4,5,6,7,8);

//Positions des bulles accueillant les nombres pour déterminer quel est le nb à cette position
var x_bulle = new Array(271,396,536,396,271,138,6,138,271);
var y_bulle = new Array(10,88,171,250,338,250,171,88,171);

//Sens de rotation : 1 ou -1
var rotation=1 - (2 * Math.floor((Math.random() * 2)));
//###rotation=1;

//Décalage par rapport au nord : de 0 à 3
//Attention !!! les nb aux "coins" appartiennent à une seule zone
//alors que les nb au milieu appartiennent à 2 zones ==> seulement 4 décalages possibles !!!
var decalage=Math.floor(Math.random() * 4); // ==> 0, 1, 2 ou 3
//###decalage=1;
switch(rotation)
{
 case 1:
  switch(decalage)
  {
   case 0: positions=Array(0,1,2,3,4,5,6,7,8);break;//nb dans l'ordre horaire en partant du nord = 8,11,4,10,1,14,5,6,12
   case 1: positions=Array(6,7,0,1,2,3,4,5,8);break;//nb=4,10,1,14,5,6,8,11,12
   case 2: positions=Array(4,5,6,7,0,1,2,3,8);break;//nb=1,14,5,6,8,11,4,10,12
   case 3: positions=Array(2,3,4,5,6,7,0,1,8);break;//nb=5,6,8,11,4,10,1,14,12
  }
 break;
 case -1:
  switch(decalage)
  {
   case 0: positions=Array(0,7,6,5,4,3,2,1,8);break;//nb dans l'ordre horaire en partant du nord = 8,6,5,14,1,10,4,11,12
   case 1: positions=Array(2,1,0,7,6,5,4,3,8);break;//nb=4,11,8,6,5,14,1,10,12
   case 2: positions=Array(4,3,2,1,0,7,6,5,8);break;//nb=1,10,4,11,8,6,5,14,12
   case 3: positions=Array(6,5,4,3,2,1,0,7,8);break;//nb=5,14,1,10,4,11,8,6,12
  }
 break;
}

//Contrôle
//var sens_rotation="normal"; if (rotation==-1)sens_rotation="inverse";
//Ecris_element("pied","Rotation de la matrice en sens " + sens_rotation + " avec  un décalage de " + decalage + " !");


//Détermination du surplus par rapport à la matrice selon le niveau
var surplus_min=0; var surplus_max=3;
switch (odg)
{
 case "2": surplus_min=4; surplus_max=15; break;
 case "3": surplus_min=16; surplus_max=240; break;
 case "4": surplus_min=241; surplus_max=2490; break;
}
//var surplus=Math.floor((Math.random() * 10) + 1);
var surplus=Math.floor((Math.random() * (surplus_max - surplus_min)) + 1 + surplus_min);
//###surplus=1;
somme_zone=somme_zone + (4 * surplus);

//Détermination des nombres "offerts" = placés automatiquement
//Selon niveau ?
var haz=0;
var gratuits="012345678";
var gratuit=new Array();
haz=Math.floor((Math.random() * gratuits.length));
//gratuit[0]=gratuits.substr(haz,1);
gratuit[0]=positions[parseInt(gratuits.substr(haz,1))].toString();
gratuits=gratuits.replace(gratuits.substr(haz,1),"");
haz=Math.floor((Math.random() * gratuits.length));
//gratuit[1]=gratuits.substr(haz,1);
gratuit[1]=positions[parseInt(gratuits.substr(haz,1))].toString();
gratuits=gratuits.replace(gratuits.substr(haz,1),"");
if(npa>2)
{
 haz=Math.floor((Math.random() * gratuits.length));
// gratuit[2]=gratuits.substr(haz,1);
 gratuit[2]=positions[parseInt(gratuits.substr(haz,1))].toString();
 gratuits=gratuits.replace(gratuits.substr(haz,1),"");
}
if(npa>3)
{
 haz=Math.floor((Math.random() * gratuits.length));
// gratuit[3]=gratuits.substr(haz,1);
 gratuit[3]=positions[parseInt(gratuits.substr(haz,1))].toString();
 gratuits=gratuits.replace(gratuits.substr(haz,1),"");
}
if(npa>4)
{
 haz=Math.floor((Math.random() * gratuits.length));
// gratuit[4]=gratuits.substr(haz,1);
 gratuit[4]=positions[parseInt(gratuits.substr(haz,1))].toString();
 gratuits=gratuits.replace(gratuits.substr(haz,1),"");
}

//Centrer les div
Centre_element("bandeau");
Centre_element("parametres");
Centre_element("fond_conteneur");
Centre_element("conteneur");
Centre_element("options");
Centre_element("page");
Centre_element("consigne");
Centre_element("pied");

zoneXmin=conteneur.offsetLeft;
zoneXmax=(conteneur.offsetLeft + conteneur.offsetWidth);
zoneYmin=conteneur.offsetTop;
zoneYmax=(conteneur.offsetTop + conteneur.offsetHeight);

var zones = document.querySelector("#conteneur");
var activeItem = null;

var active = false;

zones.addEventListener("touchstart", dragStart, false);
zones.addEventListener("touchend", dragEnd, false);
zones.addEventListener("touchmove", drag, false);

zones.addEventListener("mousedown", dragStart, false);
zones.addEventListener("mouseup", dragEnd, false);
zones.addEventListener("mousemove", drag, false);

//Affiche le fond de la grille
var fond=Cree_fond("fond","fond",-5,gy,gx);

//Affiche la zone nord
var nord=Cree_fond("nord","nord",-4,gy,gx);
nord.style.visibility="hidden"; 

//Affiche la zone est
var est=Cree_fond("est","est",-3,gy,gx);
est.style.visibility="hidden"; 

//Affiche la zone sud
var sud=Cree_fond("sud","sud",-2,gy,gx);
sud.style.visibility="hidden"; 

//Affiche la zone ouest
var ouest=Cree_fond("ouest","ouest",-1,gy,gx);
ouest.style.visibility="hidden"; 

//Affiche les bulles
var nombres=Cree_fond("nombres","nombres",-1,gy,gx);

//Affiche somme zone nord
var somme_nord=Cree_somme("nord",0,gy + 100,gx + 265,somme_zone)

//Affiche somme zone est
var somme_est=Cree_somme("est",0,gy + 180,gx + 400,somme_zone)

//Affiche somme zone sud
var somme_sud=Cree_somme("sud",0,gy + 260,gx + 265,somme_zone)

//Affiche somme zone ouest
var somme_ouest=Cree_somme("ouest",0,gy + 180,gx + 120,somme_zone)

//Affiche les 9 nombres
var decy=70; var yy=30;
var nb0 = Cree_nombre_rond("nb0",matrice[positions[0]] + surplus,"jaune",gy + yy + (decy * 0.5),gx + 700);
var nb1 = Cree_nombre_rond("nb1",matrice[positions[1]] + surplus,"jaune",gy + yy + (decy * 1.5),gx + 700);
var nb2 = Cree_nombre_rond("nb2",matrice[positions[2]] + surplus,"jaune",gy + yy + (decy * 2.5),gx + 700);
var nb3 = Cree_nombre_rond("nb3",matrice[positions[3]] + surplus,"jaune",gy + yy + (decy * 3.6),gx + 700);
var nb4 = Cree_nombre_rond("nb4",matrice[positions[4]] + surplus,"jaune",gy + yy + (decy * 0),gx + 800);
var nb5 = Cree_nombre_rond("nb5",matrice[positions[5]] + surplus,"jaune",gy + yy + (decy * 1),gx + 800);
var nb6 = Cree_nombre_rond("nb6",matrice[positions[6]] + surplus,"jaune",gy + yy + (decy * 2),gx + 800);
var nb7 = Cree_nombre_rond("nb7",matrice[positions[7]] + surplus,"jaune",gy + yy + (decy * 3),gx + 800);
var nb8 = Cree_nombre_rond("nb8",matrice[positions[8]] + surplus,"jaune",gy + yy + (decy * 4),gx + 800);

//Place les nombres gratuits
Place_nombres(gratuit[0]+gratuit[1]+gratuit[2]+gratuit[3]+gratuit[4]+gratuit[5]+gratuit[6]+" ",false,"orange");

//Validation partielle
Cache_element("bouton_puzzle");
if(vp==1) Affiche_element("bouton_puzzle");

//Affiche les paramètres du jeu
Affiche_parametres_jeu();
Regenere_barre_progression();

//Chronomètre ou minuteur ?
zz=types_scores.indexOf(score);
if(zz>0 && mode=="competition") 
{
 chrono=temps;
 Demarre_temps();
 if(zz==4)dureemaxi=180; 
 if(zz==5)dureemaxi=360; 
}

//------------
// À FAIRE !!!
//------------

//Voir positionnement nombres (à placer) au pif
//Modifier le minuteur pour que le nombre décroisse (comme les corbeaux) : initialisation, sens modif, réinitialisation, test fin
//Arrêter le temps pendant le changement de jeu (affichage de bravo ou oups)
